"""
SCript for creating clusters from data.

Start with a lexical list created some way.

Get to a Cluto-created hierarchy of words based on sim function.

Currently only cosine goes all the way through because this is
the only Cluto provided sim function that we use.  For other
experiements we need to imp[lement s sim function in the Cluto interface.
"""

import cluto_prep, cluster_tree

## Make sorted noun item list
nil = count_words ('NN', word_deprel_ct_dict=safe_word_deprel_ct_dict)

noun_list = [x[0] for x in nil]

## top 500 nouns
top_nouns = noun_list[:500]

cluto_prep.write_cluto_file(dependency_train_file,word_deprel_ct_dict, pos='NN',lexemes=top_nouns)
# This creates militant_data_DB_NN_key.clu,militant_data_DB_NN.mat
# These must be copied to Cluto_app_dir/Matrices

cluto_prep.make_row_label_file(dependency_train_file,pos='NN',lexemes = top_nouns)
## This creates militant_data_DB_NN.mat.rlabel
## This  a Cluto file format.  Not clear what we're asking Cluto to do uses it.
# This must be copied to Cluto_app_dir/Matrices


## In Cluto dir we do
## Darwin-i386/vcluster -rlabelfile=Matrices/militant_data_DB_NN.mat.rlabel -showtree -clmethod=rbr -fulltree -plotformat=ps Matrices/militant_data_DB_NN.mat 50
## We copy Matrices/militant_data*.tree, Matrices/militant_data*.

stem = 'militant_data_DB_NN'
key_file_name = '%s_key.clu' % stem
tree_file_name = '%s.mat.tree' % stem
cluster_file_name = '%s.mat.clustering.50' % stem
   
(clusters,lexemes,parents,children) = cluster_tree.get_tree('cluto/%s' % key_file_name, \
                                                            'cluto/%s' % cluster_file_name, 50, \
                                                            'cluto/%s' % tree_file_name)
## To get the stringfor ENTIRE hierarchy to put in the tex file.  NB: Tex capacity exceeded warning.
## TeX capacity exceeded, sorry [grouping levels=255]
## make_hierarchy called to make H_str
H_str = cluster_tree.make_hierarchy (children, lexemes, len(lexemes))
# You can also use get_tree to do this, but it's an obverliaded use of this fn.
# H_str = get_tree('cluto/%s' % key_file_name, \
#                 'cluto/%s' % cluster_file_name, 50, \
#                 'cluto/%s' % tree_file_name,\
#                 make_tree_str=True)

## Useful info for figuring what nodes to print in latex.
## get number of leaves dominated by each node in the hierarchy.
ns = cluster_tree.get_node_sizes(children,len(lexemes))

## Get a large chunk of the hierarchy by calling the recursive helper function
## for make_hierarchy.

## Higher number nodes created later, nodes higher in tree in agglomerative clustering.
## Contains body, gun, genocide, murder, fraud, assassination
H = cluster_tree.make_hierarchy_helper (991, children, lexemes, 500)



###############
## Exploring
#############
# >>> lexemes[:10]
# >>> lexemes[:10]
# ['1 time NN', '2 government NN', '3 % NN', '4 position NN', '5 man NN', '6 px NN', '7 \\/ NN', '8 color NN', '9 way NN', '10 world NN']
lexs = [tuple(x.split()[1:]) for x in lexemes]
# >>> lexs[:10]
#[('time', 'NN'), ('government', 'NN'), ('%', 'NN'), ('position', 'NN'), ('man', 'NN'), ('px', 'NN'), ('\\/', 'NN'), ('color', 'NN'), ('way', 'NN'), ('world', 'NN')]

gen_ind = lexs.index(('genocide','NN'))


