if __name__ == '__main__':
    from dependency_db import *
    import os.path

    home = os.environ['HOME']
    dependency_db_dir = os.path.join(home,'Desktop','SWIDSAS','dependency_DB')
    os.chdir(dependency_db_dir)

    ## Assumed to exist
    dependency_keys_file = '../dep_data/dependency_DB.keys'
    dependency_train_file = '../dep_data/dependency_DB.train'

    ## Created
    ## Various versions dependency_train_file with the same name
    ## but with suffixes and extensions aded.
    lemma_dependency_train_file = '../dep_data/lemma_dependency_DB.train'
    nearest_neighbor_file = 'nearest_neighbor.dict'
    mnn_file = 'mutual_nearest_neighbors.dict'

    # #  IRad
    # convert_to_mi(dependency_train_file,\
    #             mi_func = conditional_probs, normalize='l1',\
    #             suffix='_irad',ext='_prob')

    ###############################################################
    ## read in a IRad prob model
    (lexeme_deprel_ct_dict, lexeme_ct_dict, deprel_ct_dict, lemma_dict, total_deprels) = \
                          read_dependency_file(dependency_train_file, count_file=False, \
                                               suffix = '_IRad',ext = '_prob')


    # Apr 9 Testing IRad
    ## after having done
    ## dump_rel_nearest_neighbor_dict ('partial'+nearest_neighbor_file, pos='NN',\
    ##                                   suffix = '_IRad', ext = '_prob')
    nn_dict = {}
    rel_nearest_neighbor_dict['NN'] = nn_dict
    read_nn_file('rel__partialnearest_neighbor_NN_IRad_prob.dict',nn_dict=nn_dict)
    find_nearest_neighbors(dependency_train_file, nearest_neighbor_file,top_n=500, \
                           suffix='_IRad',ext='_prob',preserve_pos=True, pos='NN',\
                           sim_func=IRad,verbose=True)

    ###############################################################

    #### Fun things to try  ######################
    
    # nn1 = find_nearest_neighbor(('church','NN'))
    # find_nearest_n(('wants','VBZ'), 10)
    # make_neighborhood_graph(('be','VB'),5,dot_file=True)


    
